<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="计划GUID" prop="planGuid">
        <el-input v-model="queryParams.planGuid" placeholder="请输入计划GUID" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="指定名称" prop="designName">
        <el-input v-model="queryParams.designName" placeholder="请输入指定名称" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="指定状态" prop="designStat">
        <el-select v-model="queryParams.designStat" placeholder="请选择指定状态" clearable>
          <el-option v-for="dict in ttsa_design_stat" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['ttsa:ttsadesign:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['ttsa:ttsadesign:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['ttsa:ttsadesign:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['ttsa:ttsadesign:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="ttsa-ttsadesign-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="计划GUID" prop="planGuid" />
      <el-table-column label="指定名称" prop="designName" />
      <el-table-column label="指定类型" prop="designType" />
      <el-table-column label="指定状态" prop="designStat" width="120">
        <template #default="scope">
          <dict-tag :options="ttsa_design_stat" :value="scope.row.designStat" />
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['ttsa:ttsadesign:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['ttsa:ttsadesign:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="600px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="计划GUID" prop="planGuid">
          <el-input v-model="form.planGuid" placeholder="请输入计划GUID" />
        </el-form-item>
        <el-form-item label="指定名称" prop="designName">
          <el-input v-model="form.designName" placeholder="请输入指定名称" />
        </el-form-item>
        <el-form-item label="指定类型" prop="designType">
          <el-input v-model="form.designType" placeholder="请输入指定类型" />
        </el-form-item>
        <el-form-item label="组织GUID" prop="orgGuid">
          <el-input v-model="form.orgGuid" placeholder="请输入组织GUID" />
        </el-form-item>
        <el-form-item label="指定状态" prop="designStat">
          <el-select v-model="form.designStat" placeholder="请选择指定状态">
            <el-option v-for="dict in ttsa_design_stat" :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="TtsaDesign">
import { listBisTtsaDesign, getBisTtsaDesign, addBisTtsaDesign, updateBisTtsaDesign, delBisTtsaDesign } from "@/api/slaj/ttsa";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { ttsa_design_stat } = proxy.useDict("ttsa_design_stat");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ planGuid: { visible: true }, designName: { visible: true }, designType: { visible: true }, designStat: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, planGuid: null, designName: null, designStat: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisTtsaDesign(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加考核指定";
}

function handleUpdate(row) {
  reset();
  getBisTtsaDesign(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改考核指定";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisTtsaDesign(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisTtsaDesign(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisTtsaDesign(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/ttsa/ttsadesign/export', { ...queryParams.value }, `考核指定_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, planGuid: null, designName: null, designType: null, orgGuid: null, designStat: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
